;
;   Save Ramdisk to HD
;
;   Compile with FASM for Menuet
;
   
use32
   
               org    0x0
   
               db     'MENUET01'              ; 8 byte id
               dd     0x01                    ; header version
               dd     START                   ; start of code
               dd     I_END                   ; size of image
               dd     0x100000                ; memory for app
               dd     0x7fff0                 ; esp
               dd     0x0 , 0x0               ; I_Param , I_Icon

wndX equ 200   
wndY equ 180
START:                          ; start of execution
   
    mov  eax,mb_Question+mb_Yes+mb_No
    mov  ecx, (wndX-10) shl 16 + wndY  ; ecx - window position [x start]*65536+[y start]
    mov  ebx,Text1
    mov  edx,Title
    call MsgBox
    
    cmp eax,mb_ec_No
    je  quit

    call draw_window
    mov eax,18     ; save ramdisk to hd
    mov ebx,6
    int 0x40

    mov  eax,mb_Information+mb_OK
    mov  ecx,wndX shl 16 + wndY ; ecx - window position [x start]*65536+[y start]
    mov  ebx,Text2
    mov  edx,Title
    call MsgBox
    call draw_window

quit:    
    mov eax,-1
    int 0x40

draw_window:
    mov  eax,12                    ; function 12:tell os about windowdraw
    mov  ebx,1                     ; 1, start of draw
    int  0x40
                                   ; DRAW WINDOW
    mov  eax,0                     ; function 0 : define and draw window
    mov  ebx,wndX*65536+220   ; [x start] *65536 + [x size]
    mov  ecx,(wndY-10)*65536+100   ; [y start] *65536 + [y size]
    mov  edx,0x000000aa ;02        ; color of work area RRGGBB,8->color gl
    mov  esi,0x40000000 
    xor  edi,edi
    int  0x40

    mov  eax,4                     ; function 4 : write text to window
    mov  ebx,29*65536+55           ; [x start] *65536 + [y start]
    mov  ecx,0x20ddeeff            ; font 1 & color ( 0xF0RRGGBB )
    mov  edx,lblsave               ; pointer to text beginning
    mov  esi,lbllen-lblsave        ; text length
    int  0x40

    mov  eax,12                    ; function 12:tell os about windowdraw
    mov  ebx,2                     ; 2, end of draw
    int  0x40
    ret
    
    include "msgbox.inc"
    Title db 'RD2HD 2',0
    Text1 db 'Do you really wish to save ramdisk',13
          db 13
          db '       to /HD/1/menuet.img ?      ',0
    Text2 db 'Ramdisk successfully saved!',0
    lblsave db 'Saving ramdisk, please wait...'
    lbllen:
I_END:
   
   
   
   